---
title: Регламентная обработка
slug: primery-snippety-bsp-i-tipovye-dopolnitelnye-otchety-i-obrabotki-nastroyki/reglamentnaya-obrabotka
---
# Модуль объекта обработки
```bsl
#Область ПрограммныйИнтерфейс

Функция СведенияОВнешнейОбработке() Экспорт
    
    ПараметрыРегистрации = ДополнительныеОтчетыИОбработки.СведенияОВнешнейОбработке(СтандартныеПодсистемыСервер.ВерсияБиблиотеки());
    Представление = НСтр("ru='Моя регламентная обработка'", "ru");
	Идентификатор = "МояРегламентнаяОбработка";
    
    ПараметрыРегистрации.Вид = ДополнительныеОтчетыИОбработкиКлиентСервер.ВидОбработкиДополнительнаяОбработка();
    ПараметрыРегистрации.Версия = "1.0";
	ПараметрыРегистрации.БезопасныйРежим = Ложь;
	ПараметрыРегистрации.Информация = ИсторияИзмененийОбработки();
    
    Команда = ПараметрыРегистрации.Команды.Добавить();
    Команда.Представление = Представление;
    Команда.Идентификатор = Идентификатор;
    Команда.Использование = ДополнительныеОтчетыИОбработкиКлиентСервер.ТипКомандыВызовСерверногоМетода();
    Команда.ПоказыватьОповещение = Истина;
    
    // При необходимости
    Разрешение = РаботаВБезопасномРежиме.РазрешениеНаСозданиеCOMКласса("Excel.Application", "00024500-0000-0000-C000-000000000046");
    ПараметрыРегистрации.Разрешения.Добавить(Разрешение);
	
    Разрешение = РаботаВБезопасномРежиме.РазрешениеНаСозданиеCOMКласса("ADODB.Connection", "00000514-0000-0010-8000-00AA006D2EA4");
    ПараметрыРегистрации.Разрешения.Добавить(Разрешение);

    Возврат ПараметрыРегистрации;
    
КонецФункции

// Обработчик серверных команд.
//
// Параметры:
//   ИдентификаторКоманды - Строка    - имя команды, определенное в функции СведенияОВнешнейОбработке().
//   ПараметрыВыполнения  - Структура - контекст выполнения команды:
//       * ДополнительнаяОбработкаСсылка - СправочникСсылка.ДополнительныеОтчетыИОбработки - ссылка обработки.
//           Может использоваться для чтения параметров обработки.
//           Пример см. в комментарии к функции ДополнительныеОтчетыИОбработкиКлиентСервер.ТипКомандыОткрытиеФормы().
//
Процедура ВыполнитьКоманду(ИдентификаторКоманды, ПараметрыВыполнения) Экспорт
	
	...
	<Логика, которая будет выполняться>
	...
	
КонецПроцедуры

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Функция ИсторияИзмененийОбработки() 
	
	СписокИзменений = Новый Массив;
	СписокИзменений.Добавить("История изменений:");
	СписокИзменений.Добавить("2025-04-16, УЗГА, Создание обработки, версия 1.0");
	СписокИзменений.Добавить("Общая информация: <Что, зачем, почему>");
	
	Возврат СтрСоединить(СписокИзменений, Символы.ПС);
	
КонецФункции

#КонецОбласти
```